#ifndef STATISTIC_H
#define STATISTIC_H

#include <string>
#include <strstream>

using namespace std;

class Statistic
{
 public:
  Statistic();

  std::string   str(const double value, const int prec = 0);

  const long    in_all_n();
  const long    in_all_b();
  const long    out_all_n();
  const long    out_all_b();
  const long    hits_all_n();

  long    in_ping_n;
  long    in_pong_n;
  long    in_query_n;
  long    in_hit_n;
  long    in_push_n;

  long    in_ping_b;
  long    in_pong_b;
  long    in_query_b;
  long    in_hit_b;
  long    in_push_b;

  long    out_ping_n;
  long    out_pong_n;
  long    out_query_n;
  long    out_hit_n;
  long    out_push_n;

  long    out_ping_b;
  long    out_pong_b;
  long    out_query_b;
  long    out_hit_b;
  long    out_push_b;

  long    hits_qtel_n;
  long    hits_lime_n;
  long    hits_bear_n;
  long    hits_othe_n;

  double  loads_usucc;
  double  loads_uabor;
  double  loads_usize;
  double  loads_dsucc;
  double  loads_dabor;
  double  loads_dsize;

  double shared_files;
  double shared_size;
};

#endif
