#include "QueryHitEntry.h"

const int QueryHitEntry::Busy = 1;
const int QueryHitEntry::Ready = 2;
const int QueryHitEntry::Firewalled = 4;
const int QueryHitEntry::Unknown = 8;

QueryHitEntry::QueryHitEntry(std::string& filename, const uint32_t size, const uint32_t index, const uint32_t speed, int status, Address& addr, std::string& id, QListViewItem *item)
{
  this->filename = filename;
  this->size = size;
  this->index = index;
  this->addr = addr;
  this->id = id;
  this->item = item;
  this->speed = speed;
  this->status = status;
}

QueryHitEntry::QueryHitEntry()
{
  filename = "";
  size = 0;
  index = 0;
  addr = Address();
  id = "";
  item = NULL;
  speed = 0;
  status = Unknown;
}

QueryHitEntry::~QueryHitEntry()
{
}


bool QueryHitEntry::firewalled()
{
  return ( (status&Firewalled) > 0);
}
