#include "../include/SearchWidget.h"
#include "QtellaSub.h"
#include <qlistview.h>

/* 
 *  Constructs a SearchWidget which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
SearchWidget::SearchWidget( QWidget* parent,  const char* name, WFlags fl )
    : SearchWidgetBase( parent, name, fl )
{
  this->parent = (QtellaSub*) parent;

  ui_listview_search->setColumnWidthMode(0, QListView::Manual);
  ui_listview_search->setColumnWidthMode(1, QListView::Manual);
  ui_listview_search->setColumnWidthMode(2, QListView::Manual);
  ui_listview_search->setColumnWidthMode(3, QListView::Manual);
  ui_listview_search->setColumnWidth(0, 7*10);
  ui_listview_search->setColumnWidth(1, 35*10);
  ui_listview_search->setColumnWidth(2, 10*10);
  ui_listview_search->setColumnWidth(3, 10*10);
  ui_listview_search->setColumnAlignment(0, AlignHCenter);
  ui_listview_search->setColumnAlignment(1, AlignLeft);
  ui_listview_search->setColumnAlignment(2, AlignRight);
  ui_listview_search->setColumnAlignment(3, AlignRight);

  ui_listview_search->setShowSortIndicator(true);
  ui_listview_search->setSorting(1, true);        // sort filenames by default
}

/*  
 *  Destroys the object and frees any allocated resources
 */
SearchWidget::~SearchWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

/* 
 * public slot
 */
void SearchWidget::slotDoubleClick(QListViewItem *item)
{
  doubleClicked(item);
}

